<?php

require_once 'base/FpaParamfolhamEntityBase.php';

/**
 * This class has been auto-generated by Setforms
 *
 * @package Entity
 *
 * @author  alessandrobartels
 */
class FpaParamfolhamEntity extends FpaParamfolhamEntityBase
{

    private $_nrOrg;
    private $_nrOrgPadrao;
    private $_mesCompetencia;

    private $_paramFolha;
    private $_nrParamFolhaAnterior;


     /**
     * Construtor.
     *
     * @param integer 	 $id			 Identificador.
     * @param integer 	 $nrOrg			 Numero da organizacao de trabalho.
     * @param integer    $nrOrgPadrao	 Numero da organizacao padrao.
     * @param TkDateTime $mesCompetencia Mes de competencia.
     *
     * @author alessandrobartels - 02/12/11
     */
    public function __construct($id = null, $nrOrg = null, $nrOrgPadrao = null, TkDateTime $mesCompetencia = null){

        parent::__construct($id);

        $this->_nrOrg = $nrOrg;
        $this->_nrOrgPadrao = $nrOrgPadrao;
        $this->_mesCompetencia = $mesCompetencia;
        $this->_nrParamFolhaAnterior = -1;

    }


     /**
     * Tipo de arredondamento.
     *
     * @return string
     *
     * @author alessandrobartels - 02/12/11
     */
    public function getTipoArredondamento(){
        if (is_object($this->_paramFolha) === true) {
            return $this->_paramFolha->historico->getIdtparredondame();
        }
    }


     /**
     * Numero de digitos de arredondamento (casas decimais).
     *
     * @return integer
     *
     * @author alessandrobartels - 02/12/11
     */
    public function getDigitoArredondamento(){
        if (is_object($this->_paramFolha) === true) {
            return $this->_paramFolha->historico->getNrdigarredondam();
        }
    }


     /**
     * Limite do digito para arredondamento.
     *
     * @return integer
     *
     * @author alessandrobartels - 02/12/11
     */
    public function getLimiteArredondamento(){
        if (is_object($this->_paramFolha) === true) {
            return $this->_paramFolha->historico->getNrlimarredondam();
        }
    }


    /**
     * Numero do Grupo de Incidencia
     *
     * @return integer
     *
     * @author alessandrobartels - 26/06/2012
     */
    public function getGrupoIncidencia(){
        if (is_object($this->_paramFolha) === true) {
            return $this->_paramFolha->historico->getNrgrpincide();
        }
    }


    /**
     * Controle de dias mensais para Admissao
     *
     * @return integer
     *
     * @author alessandrobartels - 03/09/2012
     */
    public function getControleAdmissao(){
        if (is_object($this->_paramFolha) === true) {
            return $this->_paramFolha->historico->getNrctrladmissao();
        }
    }


    /**
     * Flag para identificar se acumula IR com recolhimento minimo
     *
     * @return string
     *
     * @author alessandrobartels - 10/09/2012
     */
    public function getAcumulaIRRecolhimentoMinimo(){
        if (is_object($this->_paramFolha) === true) {
            return $this->_paramFolha->historico->getIdirrfrecolhmin();
        }
    }


    /**
     * Percentual para adiantamento salarial
     *
     * @return float
     *
     * @author alessandrobartels - 16/10/2012
     */
    public function getPercentualAdiantamento(){
        if (is_object($this->_paramFolha) === true){
            return $this->_paramFolha->historico->getVrpercentadiant();
        }
    }


    /** Numero minimo de dias para pagamento do adiantamento salarial
     *
     * @return integer
     *
     * @author alessandrobartels - 16/10/2012
     */
    public function getNumeroMinimoAdiantamento(){
        if (is_object($this->_paramFolha) === true){
            return $this->_paramFolha->historico->getNrmindiasadiant();
        }
    }

    /** Recebe Adiantamento no mes de Admissão?
     *
     * @return integer
     *
     * @author brunoborba - 30/07/2013
     */
    public function getIdRecebeAdiantPriMes(){
        if (is_object($this->_paramFolha) === true){
            return $this->_paramFolha->historico->getIdrecadianprimes();
        }
    }

    /**
     * Controle de dias mensais para Retorno de Ferias
     *
     * @return integer
     *
     * @author BORBA - 04/08/2014
     */
    public function getControleFerias(){
        if (is_object($this->_paramFolha) === true) {
            return $this->_paramFolha->historico->getNrctrlferias();
        }
    }

    /**
     * Controle de dias mensais para Retorno de Afastamento
     *
     * @return integer
     *
     * @author BORBA - 04/08/2014
     */
    public function getControleAfastamento(){
        if (is_object($this->_paramFolha) === true) {
            return $this->_paramFolha->historico->getNrctrlafast();
        }
    }

    /**
     * Procura o parametro de folha na lista.
     *
     * @param integer $nrParamFolha Numero do parametro de folha.
     *
     * @return void
     *
     * @author alessandrobartels - 02/12/11
     */
    public function procuraParamFolha($nrParamFolha){

        if ($this->_nrParamFolhaAnterior !== $nrParamFolha) {
            $itens = $this->getItems();
            if (count($itens) === 0) {
                $this->_inicializaListaParametroFolha();
                $itens = $this->getItems();
            }

            foreach ($itens as $key=>$item) {
                if ((int)$item->getNrparamfolham() === (int)$nrParamFolha) {
                    $this->_paramFolha = $this->getItem($key);
                    break;
                }
            }
        }
    }


     /**
     * Adiciona na lista instancias de FpaparamfolhamEntity agregado com FpaparamfolhahEntity.
     *
     * @throws Exception $e Propaga excecao.
     *
     * @return void
     *
     * @author thalesvalias - 21/11/11
     *         alessandrobartels - 02/12/11 - Retorna da base todos os parametros relacionados a Org e a Org Padrao.
     *         								  Adiciona estes parametros na lista.
     */
    private function _inicializaListaParametroFolha(){
        try {
            $itens = FpaParamfolham::retornaParametrosFolha($this->_nrOrg, $this->_nrOrgPadrao, $this->_mesCompetencia);

            if(count($itens)==0){
                throw new Exception('Não foi encontrado parâmetro de folha ou o mesmo está incorreto para a estrutura. Confira os parâmetros de estrutura.');
            }

            foreach ($itens as $item) {
                $this->addItem($item);
            }
        } catch(Exception $e) {
            throw $e;
        }

    }

    /**
     * @param $nrorg
     *
     * @return FpaParamfolhamEntity
     * @autor jorgefonseca
     */
    public static function getByNrorg($nrorg) {
        $result = self::getEntityByWhere('NRORG = ?', array($nrorg));
        return $result;
    }

}

